package bttool;

import java.awt.*;
import java.awt.event.*;

public class Controller
implements ActionListener
{

  //Das Frame zur Darstellung
  public Frame mainFrame;

  //Label fr die Bezeichnung
  public Label mechBezeichnung [];

  //Label fr den Zustand
  public Label mechZustand [];

  //Das Men
  private mainMenu menu;

  //Textfelder fr die Figur
  private TextField figurTF [];

  //Textfelder fr die Treffer
  private TextField trefferTF [];

  //Buttons
  private Button figurAendern;
  private String BUTTON_FIGUR_AENDERN = "Figuren ndern";
  private Button trefferKalkulieren;
  private String BUTTON_TREFFER_KALKULIEREN = "Treffer Kalkulieren";

//################################################################################################
//Ende der Variablen, Beginn der Methoden mit den Konstrukturen
//################################################################################################

  public Controller(){this.menu = new mainMenu(this);}

  public static void main(String[] args)
  {

    //Ein try- Catch Block, damit die Anwendung nicht
    //Abstrzt, wenn eine Exception auftritt.
    try
    {
      //das Kontrollfenster anlegen und anzeigen
      Controller controller = new Controller();
      controller.anzeigen();
    }
    catch (Exception e)
    {
      System.out.println(e.toString());
    }

  }

  /**
   * Zur Anzeige wird jedesmal diese Methode aufgerufen.
   */
  public void anzeigen()
  {
      //mgliche vorhandene alte Frames lschen.
      if(this.mainFrame != null){this.mainFrame.setVisible(false);this.mainFrame = null;}

      this.mainFrame = new Frame("Kontrolle");
      this.mainFrame.setSize(600,700);

      this.mainFrame.setMenuBar(this.menu);
      this.mainFrame.setLayout(null);

      String name;
      String figur;

      //Die Labels aller Mechs
      this.mechBezeichnung = new Label[this.menu.schlacht.size()];
      //Die Textfelder der Figur aller Mechs
      this.figurTF = new TextField[this.menu.schlacht.size()];
      //Die Textfelder aller Treffer
      this.trefferTF = new TextField[this.menu.schlacht.size()];
      //Die Labels der Zustnde aller Mechs
      this.mechZustand = new Label[this.menu.schlacht.size()];

      //Labels der Mechbezeichnungen anzeigen
      for(int i=0; i<this.mechBezeichnung.length; i++)
      {
        name = ((Mech) this.menu.schlacht.get(i)).parameterValues[0];
        this.mechBezeichnung[i] = new Label();
        this.mechBezeichnung[i].setFont(new Font("Arial",Font.BOLD,12));
        this.mechBezeichnung[i].setBounds(10, 80+i*22, 100, 20);
        if(Integer.parseInt(((Mech) this.menu.schlacht.get(i)).parameterValues[6]) == 0)
        {
          this.mechBezeichnung[i].setBackground(Color.green);
        }
        else
        {
          this.mechBezeichnung[i].setBackground(Color.red);
        }
        this.mechBezeichnung[i].setText(name);
        this.mainFrame.add(this.mechBezeichnung[i]);
      }

      //Textfelder anzeigen
      for(int i=0; i<this.figurTF.length; i++)
      {
        figur = ((Mech) this.menu.schlacht.get(i)).parameterValues[2];
        this.figurTF[i] = new TextField(figur);
        this.figurTF[i].setFont(new Font("Arial",Font.BOLD,12));
        this.figurTF[i].setBounds(120,80+i*22,120,20);
        this.mainFrame.add(this.figurTF[i]);
      }

      //Textfelder fr die Treffer
      for(int i=0; i<this.figurTF.length; i++)
      {
        this.trefferTF[i] = new TextField(((Mech) this.menu.schlacht.get(i)).inhaltTextAreaTreffer);
        this.trefferTF[i].setFont(new Font("Arial",Font.BOLD,12));
        this.trefferTF[i].setBounds(260,80+i*22,120,20);
        this.mainFrame.add(this.trefferTF[i]);
      }

      //Labels der Mechzustnde anzeigen
      for(int i=0; i<this.mechBezeichnung.length; i++)
      {
        this.mechZustand[i] = new Label();
        this.mechZustand[i].setFont(new Font("Arial",Font.BOLD,12));
        this.mechZustand[i].setBounds(390, 80+i*22, 180, 20);
//        this.mechBezeichnung[i].setBackground(Color.green);
        this.mechZustand[i].setText(((Mech) this.menu.schlacht.get(i)).meldungenKritische.getText());
        this.mainFrame.add(this.mechZustand[i]);
      }

      //Button Figur ndern, aber nur, wenn es auch etwas zu ndern gibt
      if(this.figurTF.length>0)
      {
        this.figurAendern = new Button(this.BUTTON_FIGUR_AENDERN);
        this.figurAendern.addActionListener(this);
        this.figurAendern.setBounds(120, 50, 120, 24);
        this.mainFrame.add(this.figurAendern);
      }

      //Button Treffer berechnen
      if(this.figurTF.length>0)
      {
        this.trefferKalkulieren = new Button(this.BUTTON_TREFFER_KALKULIEREN);
        this.trefferKalkulieren.addActionListener(this);
        this.trefferKalkulieren.setBounds(260, 50, 120, 24);
        this.mainFrame.add(this.trefferKalkulieren);
      }

      this.mainFrame.show();
  }

//################################################################################################
//Events
//################################################################################################

  /**
   * Diese Methode fngt alle Events ab und behandelt diese.
   */
  public void actionPerformed(ActionEvent event)
  {

    ////////////////////////////////////////////////////////////
    //Figur soll gendert werden
    if(event.getActionCommand().equals(this.BUTTON_FIGUR_AENDERN))
    {
      for(int i=0; i<this.figurTF.length; i++)
      {
        ((Mech) this.menu.schlacht.get(i)).parameterValues[2] = this.figurTF[i].getText();
      }
    }

    ////////////////////////////////////////////////////////////
    //Treffer kalkulieren
    if(event.getActionCommand().equals(this.BUTTON_TREFFER_KALKULIEREN))
    {
      Mech mech = new Mech();
      for(int i=0; i<this.trefferTF.length; i++)
      {
        if(this.trefferTF[i].getText().length()>3)
        {
          //es steht sogar was nennenswertes drin

          mech = (Mech) this.menu.schlacht.get(i);

          mech.inhaltTextAreaTreffer = this.trefferTF[i].getText();

          boolean inhaltOK = mech.checkAndSplitTextValue();

          if(inhaltOK)
          {
            /*Verarbeitung*/
            //alle Treffer verarbeiten
            mech.doAlleTreffer();
            mech.recalculateHits();
            //Bild neu Zeichnen
            mech.setVisible(false);
            mech.show();
            //Text setzen
            mech.inhaltTextAreaTreffer = "";
            mech.textTreffer.setText(mech.inhaltTextAreaTreffer);
            mech.meldungenSystem.setText("Treffer sind bearbeitet");
          }
          else
          {
            /*keine Verarbeitung*/
            mech.meldungenSystem.setText("Fehler => keine Bearbeitung");
            mech.textTreffer.setText(mech.inhaltTextAreaTreffer);
          }

        }
        else
        {
          this.trefferTF[i].setText("");
        }
      }
    }

    this.anzeigen();
  }
}