package bttool;

/**
 * Diese Klasse bildet einen Mech ab, inklusiv aller Attribute und
 * Methoden, womit sich dieser anzeigen, speichern, laden oder beschieen
 * lt.
 */
import java.awt.*;
import java.util.*;
import java.awt.event.*;
import java.awt.TextArea;
import java.awt.event.TextEvent;

public class Mech extends Frame implements ActionListener
{
  /**
   * @todo: wenn TorosMitte weggekreuzt wurde, dann ist der Mech kaputt
   */

  //wtStatus: 1=normal, 2=double
  //mechStatus: 1=ok, 2=Mech zerstrt, 3=Pilot tot, 4=Bewegungsunfhig

  //Zu Ladende oder Speichernde Strings
  public String parameterNamen[] = {"name","farbe","figur","gewicht","reaktortype",
                                    "mechtype","mechStatus","wtStatus","sollGSGeh","sollGSLauf",
                                    "sollGSJump","sollWT","sollInterne","sollPanzerung","sollPilotMechpilot",
                                    "sollPilotGunnery","sollPilotReaktion","istHitsReaktor","istHitsPilot","istHitsLifeSupport",
                                    "istHitsGyro","istInterne","istPanzerung","istWT","istHeat"};

  //Equipment
  private Vector equipment;

  //Interne Beschreibungen
  private String rArm [] = {"","","","","","","","","","","",""};
  private String lArm [] = {"","","","","","","","","","","",""};
  private String rBein [] = {"","","","","",""};
  private String lBein [] = {"","","","","",""};
  private String rTorso [] = {"","","","","","","","","","","",""};
  private String lTorso [] = {"","","","","","","","","","","",""};
  private String mTorso [] = {"","","","","","","","","","","",""};
  private String Kopf [] = {"","","","","",""};

  //Panzerung 0=RArm, 1=RBein, 2=RTorsoFront, 3=RTorsoBack, 4=TMitteFront, 5=TMitteBack,
  //6=LTorsoFront, 7=LTorsoBack, 8=LBein, 9=LArm, 10=Kopf
  private int [] sollPanzerung = {0,0,0,0,0,0,0,0,0,0,0};
  private int [] istPanzerung = {0,0,0,0,0,0,0,0,0,0,0};

  //Interne 0=RArm, 1=RBein, 2=RTorso, 3=TM, 4=LTorso, 5=LBein, 6=LArm, 7=Kopf
  private int [] sollInterne = {0,0,0,0,0,0,0,0};
  private int [] istInterne = {0,0,0,0,0,0,0,0};

  //in welcher Zone sind wieviel kritische Aufgetreten?
  //0=RArm, 1=RBein, 2=RTorso, 3=TM, 4=LTorso, 5=LBein, 6=LArm, 7=Kopf
  //Soll: soviele sollten behandelt sein, ist: soviele sind behandelt
  private int [] sollKritische = {0,0,0,0,0,0,0,0};
  private int [] istKritische = {0,0,0,0,0,0,0,0};

  //Der Inhalt obiger Strings
  public String parameterValues[] = {"","","","","",
                                    "","","","","",
                                    "","","","","",
                                    "","","","","",
                                    "","","","",""};

  public String beschreibungMechStatus [] = {"Mech ok", "Mech zerstrt", "Pilot tot", "Bewegungsunfhig"};

  //Variablen, um einen bestimmten Istzustand abbilden zu knnen.
  private   int istWT;
  private   int istHitsReaktor;
  private   int istHitsGyro;
  private   int istHitsLifeSupport;
  private   int istHitsPilot;
  private   int istHeat;

  //Alle bentigten Buttons
  private Button buttonTreffer;
  private Button buttonSpeicher;
  private Button buttonEinpflegen;

  //Konstante
  private String BUTTON_TREFFER_KALKULIEREN = "Treffer kalkulieren";
  private String BUTTON_MECH_SPEICHERN = "Speichern";
  private String BUTTON_EINPFLEGEN = "X";

  //Alle bentigten Textfelder und assoziierte Variablen
  public TextArea textTreffer;
  public String inhaltTextAreaTreffer = "";
  private Vector einzelneTreffer;

  private TextField istKritischTF [] = new TextField[8];

  private TextField istHeatTF = new TextField();

  //Fr Kritische Bentigte Texteingabe

  //bentigte Label
  public Label meldungenSystem;
  public Label meldungenKritische;
  public Label meldungenZustand;

  //bentigte Checkboxes fr Intern; 0=false=kaputt, 1=true=heil
  private Checkbox rArmCB [] = new Checkbox[12];
  private Checkbox lArmCB [] = new Checkbox[12];
  private Checkbox rTorsoCB [] = new Checkbox[12];
  private Checkbox lTorsoCB [] = new Checkbox[12];
  private Checkbox mTorsoCB [] = new Checkbox[12];
  private Checkbox rBeinCB [] = new Checkbox[6];
  private Checkbox lBeinCB [] = new Checkbox[6];
  private Checkbox KopfCB [] = new Checkbox[6];

  //bentigte Checkboxes fr Reaktor/ Gyro und LifeSupport Hits
  private Checkbox reaktorCB [] = new Checkbox[3];
  private Checkbox gyroCB [] = new Checkbox[2];
  private Checkbox lifeSupportCB [] = new Checkbox[2];
  private Checkbox hitsPilotCB [] = new Checkbox[6];

  //bentigte Checkboxes, ob eine Location dran ist
  private Checkbox locationIstDran [] = new Checkbox[8];

  //Utility
  private calcLocation calc;

  //File und Pfadangaben frs Laden und Speichern
  public String fileLaden = "C:\\test_aut2.txt";
  public String fileSpeichern = "C:\\test_aut3.txt";

//################################################################################################
//Ende der Variablen, Beginn der Methoden mit den Konstrukturen
//################################################################################################

  public Mech()
  {
    this ("unknown");
  }

  public Mech(String fileName)
  {

    this.fileLaden = fileName;
    this.fileSpeichern = fileName;

    this.equipment = new Vector();
    this.calc = new calcLocation();

    //die Checkboxen initialiseren
    this.reaktorCB[0] = new Checkbox("");
    this.reaktorCB[1] = new Checkbox("");
    this.reaktorCB[2] = new Checkbox("");

    this.gyroCB[0] = new Checkbox("");
    this.gyroCB[1] = new Checkbox("");

    this.lifeSupportCB[0] = new Checkbox("");
    this.lifeSupportCB[1] = new Checkbox("");

    for(int i=0; i<12; i++)
    {
      this.rArmCB[i] = new Checkbox("");
      this.lArmCB[i] = new Checkbox("");
      this.rTorsoCB[i] = new Checkbox("");
      this.lTorsoCB[i] = new Checkbox("");
      this.mTorsoCB[i] = new Checkbox("");
      if(i<8){this.istKritischTF[i] = new TextField();}
      if(i<8){this.locationIstDran[i] = new Checkbox(); this.locationIstDran[i].setState(true);}
    }
    for(int i=0; i<6; i++)
    {
      this.rBeinCB[i] = new Checkbox("");
      this.lBeinCB[i] = new Checkbox("");
      this.KopfCB[i] = new Checkbox("");
      this.hitsPilotCB[i] = new Checkbox("");
    }

    //Parameter fr das Frame
    this.setSize(820,760);
    this.setLocation(200,0);
    this.addWindowListener(new WindowClosingAdapter(true));
  }

//################################################################################################
//Methoden zum Laden und Speichern
//################################################################################################


  /**
   * Die Daten dieses Mechs werden eingelesen und auf die
   * eigene Datendarstellung gemapped.
   */
  public void laden()
  {
    lade mechFile = new lade();
    mechFile.einlesenFile(this.fileLaden);
    this.parametriesieren(mechFile);
  }

  /**
   * Diese Methode bereitet die Speicherung ber die Klasse speicher
   * vor. D.h. es wird eine Instanz von speicher erzeugt, alle zu
   * speichernden namen:value pairs in einen Vector geschrieben
   * und dieser wird dann gespeichert.
   */
  public void speichern()
  {
      /**@todo: speichern: die Checkbox, Location ist noch dran, mu auch gespeichert werden.*/

    speicher mechFile = new speicher();
    int kaputtOderNicht;

    //Wichtiger Text:
    mechFile.inhaltV.addElement("#Kommentare immer mit # beginnen,\r\n#keine Formatierungen hinterlassen, wie einrcken, Leerzeichen oder hnliches\r\n");

    //bertragung der Internen
    this.parameterValues[21]=""+this.istInterne[0];
    for(int i=1; i<this.istInterne.length;i++)
    {
      this.parameterValues[21]+=","+this.istInterne[i];
    }

    //bertragung der Panzerung
    this.parameterValues[22]=""+this.istPanzerung[0];
    for(int i=1; i<this.istPanzerung.length;i++)
    {
      this.parameterValues[22]+=","+this.istPanzerung[i];
    }

    //Fehlende Parameter
    this.parameterValues[23] = ""+((int) this.istWT / Integer.parseInt(this.parameterValues[7]));
    this.parameterValues[24] = ""+this.istHeat;
    this.parameterValues[18] = ""+this.istHitsPilot;
    this.parameterValues[20] = ""+this.istHitsGyro;
    this.parameterValues[19] = ""+this.istHitsLifeSupport;
    this.parameterValues[17] = ""+this.istHitsReaktor;

    //Alle Normalen Werte in den Vector zur Speicherung bertragen
    for(int i=0; i<this.parameterNamen.length; i++)
    {
      mechFile.inhaltV.addElement(this.parameterNamen[i]+":"+this.parameterValues[i]);
    }

    //Equipment in den Vector bertragen
    for (int i=0; i<this.equipment.size(); i++)
    {
      mechFile.inhaltV.addElement("equipment"+i+":"+this.equipment.get(i));
    }

    //Interne Belegung in den Vector bertragen
    for(int i=1; i<=12; i++)
    {
      if(this.rArmCB[i-1].getState()){kaputtOderNicht=1;}else{kaputtOderNicht=0;}
      mechFile.inhaltV.addElement("RArm"+i+":"+this.rArm[i-1]+","+kaputtOderNicht);

      if(this.lArmCB[i-1].getState()){kaputtOderNicht=1;}else{kaputtOderNicht=0;}
      mechFile.inhaltV.addElement("LArm"+i+":"+this.lArm[i-1]+","+kaputtOderNicht);

      if(this.mTorsoCB[i-1].getState()){kaputtOderNicht=1;}else{kaputtOderNicht=0;}
      mechFile.inhaltV.addElement("MTorso"+i+":"+this.mTorso[i-1]+","+kaputtOderNicht);

      if(this.rTorsoCB[i-1].getState()){kaputtOderNicht=1;}else{kaputtOderNicht=0;}
      mechFile.inhaltV.addElement("RTorso"+i+":"+this.rTorso[i-1]+","+kaputtOderNicht);

      if(this.lTorsoCB[i-1].getState()){kaputtOderNicht=1;}else{kaputtOderNicht=0;}
      mechFile.inhaltV.addElement("LTorso"+i+":"+this.lTorso[i-1]+","+kaputtOderNicht);

      if(i<=6)
      {
        if(this.rBeinCB[i-1].getState()){kaputtOderNicht=1;}else{kaputtOderNicht=0;}
        mechFile.inhaltV.addElement("RBein"+i+":"+this.rBein[i-1]+","+kaputtOderNicht);

        if(this.lBeinCB[i-1].getState()){kaputtOderNicht=1;}else{kaputtOderNicht=0;}
        mechFile.inhaltV.addElement("LBein"+i+":"+this.lBein[i-1]+","+kaputtOderNicht);

        if(this.KopfCB[i-1].getState()){kaputtOderNicht=1;}else{kaputtOderNicht=0;}
        mechFile.inhaltV.addElement("Kopf"+i+":"+this.Kopf[i-1]+","+kaputtOderNicht);
      }
    }

     //hier erfolgt die Speicherung
    mechFile.speichernFileV(this.fileSpeichern);
  }

  /**
   * Hier findet das Datenmapping: einlesen der Daten, eigene Datendarstellung statt.
   */
  public void parametriesieren(lade mechFile)
  {
    String newEquipment;
    int zeigerEquipment=0;
    int zeigerIntern=1;
    String dummy;

    //einlesen der Daten in das Array.
    for(int i=0; i<this.parameterNamen.length; i++)
    {
      this.parameterValues[i] = (String) mechFile.inhalt.get((String) this.parameterNamen[i]);
    }

    //Interne Belegung extrahieren
    for(zeigerIntern = 1; zeigerIntern <= this.rArm.length; zeigerIntern++)
    {
      dummy = mechFile.inhalt.get("RArm"+zeigerIntern).toString();
      this.rArm[zeigerIntern-1] = ""+dummy.substring(0,dummy.length()-2);
      if(dummy.charAt(dummy.length()-1) == '0'){this.rArmCB[zeigerIntern-1].setState(false);}
      else{this.rArmCB[zeigerIntern-1].setState(true);}

      dummy = mechFile.inhalt.get("LArm"+zeigerIntern).toString();
      this.lArm[zeigerIntern-1] = ""+dummy.substring(0,dummy.length()-2);
      if(dummy.charAt(dummy.length()-1) == '0'){this.lArmCB[zeigerIntern-1].setState(false);}
      else{this.lArmCB[zeigerIntern-1].setState(true);}

      dummy = mechFile.inhalt.get("RTorso"+zeigerIntern).toString();
      this.rTorso[zeigerIntern-1] = ""+""+dummy.substring(0,dummy.length()-2);
      if(dummy.charAt(dummy.length()-1) == '0'){this.rTorsoCB[zeigerIntern-1].setState(false);}
      else{this.rTorsoCB[zeigerIntern-1].setState(true);}

      dummy = mechFile.inhalt.get("LTorso"+zeigerIntern).toString();
      this.lTorso[zeigerIntern-1] = ""+""+dummy.substring(0,dummy.length()-2);
      if(dummy.charAt(dummy.length()-1) == '0'){this.lTorsoCB[zeigerIntern-1].setState(false);}
      else{this.lTorsoCB[zeigerIntern-1].setState(true);}

      dummy = mechFile.inhalt.get("MTorso"+zeigerIntern).toString();
      this.mTorso[zeigerIntern-1] = ""+""+dummy.substring(0,dummy.length()-2);
      if(dummy.charAt(dummy.length()-1) == '0'){this.mTorsoCB[zeigerIntern-1].setState(false);}
      else{this.mTorsoCB[zeigerIntern-1].setState(true);}

      if(zeigerIntern<=6)
      {
        dummy = mechFile.inhalt.get("Kopf"+zeigerIntern).toString();
        this.Kopf[zeigerIntern-1] = ""+""+dummy.substring(0,dummy.length()-2);
        if(dummy.charAt(dummy.length()-1) == '0'){this.KopfCB[zeigerIntern-1].setState(false);}
        else{this.KopfCB[zeigerIntern-1].setState(true);}

        dummy = mechFile.inhalt.get("RBein"+zeigerIntern).toString();
        this.rBein[zeigerIntern-1] = ""+""+dummy.substring(0,dummy.length()-2);
        if(dummy.charAt(dummy.length()-1) == '0'){this.rBeinCB[zeigerIntern-1].setState(false);}
        else{this.rBeinCB[zeigerIntern-1].setState(true);}

        dummy = mechFile.inhalt.get("LBein"+zeigerIntern).toString();
        this.lBein[zeigerIntern-1] = ""+""+dummy.substring(0,dummy.length()-2);
        if(dummy.charAt(dummy.length()-1) == '0'){this.lBeinCB[zeigerIntern-1].setState(false);}
        else{this.lBeinCB[zeigerIntern-1].setState(true);}
      }
    }

    //Panzerung und Interne extrahieren
    this.istPanzerung = zerlegtStringZuInt((String) mechFile.inhalt.get("istPanzerung"), 11);
    this.sollPanzerung = zerlegtStringZuInt((String) mechFile.inhalt.get("sollPanzerung"), 11);
    this.istInterne = zerlegtStringZuInt((String) mechFile.inhalt.get("istInterne"), 8);
    this.sollInterne = zerlegtStringZuInt((String) mechFile.inhalt.get("sollInterne"), 8);

    //Ist die Location noch dran?
    for(int i=0; i<8; i++)
    {
      if(this.istInterne[i]==0){this.locationIstDran[i].setState(false);}
    }

    //Equipment in einen Vector extrahieren
    newEquipment = (String) mechFile.inhalt.get("equipment"+zeigerEquipment);
    while(newEquipment != null && zeigerEquipment < 11)
    {
      this.equipment.add(newEquipment);
      zeigerEquipment++;
      newEquipment = (String) mechFile.inhalt.get("equipment"+zeigerEquipment);
    }

    //Wichtige Restinformationen extrahieren
    this.istWT = Integer.parseInt(this.parameterValues[23]) * Integer.parseInt(this.parameterValues[7]);
    this.istHeat = Integer.parseInt(this.parameterValues[24]);

    this.istHitsReaktor = Integer.parseInt(this.parameterValues[17]);
    for(int i=2; i>=istHitsReaktor; i--)
    {this.reaktorCB[i].setState(true);}

    this.istHitsPilot = Integer.parseInt(this.parameterValues[18]);
    for(int i=5; i>=istHitsPilot; i--)
    {this.hitsPilotCB[i].setState(true);}

    this.istHitsGyro = Integer.parseInt(this.parameterValues[20]);
    for(int i=1; i>=istHitsGyro; i--)
    {this.gyroCB[i].setState(true);}

    this.istHitsLifeSupport = Integer.parseInt(this.parameterValues[19]);
    for(int i=1; i>=istHitsLifeSupport; i--)
    {this.lifeSupportCB[i].setState(true);}
  }

  public int [] zerlegtStringZuInt(String ganzeZeile, int anzahl)
  {
    int [] returnInt = new int[anzahl];
    String [] tempArray = new String[anzahl];
    tempArray = substring(ganzeZeile,',');
    for(int i=0; i<tempArray.length; i++)
    {
      returnInt[i] = Integer.parseInt(tempArray[i]);
    }
    return (returnInt);
  }

  /**
   * Diese Methode erhlt einen String, welcher Felder nur mit einem
   * bestimmten Trennzeichen getrennt enthlt. Dieser wird zerlegt
   * und die einzelnen Felder als String Array zurck geliefert.
   */
  public String [] substring(String ganzeZeile, char trennzeichen)
  {
    int anzahlFelder=1;

    int zeigerElement=0;
    int zeigerFelder=0;

    //Wieviele Elemente gibt es?
    for(int i=0; i<ganzeZeile.length(); i++)
    {
      if(ganzeZeile.charAt(i)==trennzeichen)
      {
        anzahlFelder++;
      }
    }

    String [] returnString = new String[anzahlFelder];

    while (zeigerElement<ganzeZeile.length())
    {

      if(ganzeZeile.indexOf(',',zeigerElement)==-1)
      {
        returnString[zeigerFelder]=ganzeZeile.substring(ganzeZeile.lastIndexOf(',')+1);
        zeigerElement=ganzeZeile.length();
      }
      else
      {
        returnString[zeigerFelder]=ganzeZeile.substring(zeigerElement,ganzeZeile.indexOf(',',zeigerElement));
        zeigerElement=ganzeZeile.indexOf(',',zeigerElement)+1;
      }
      zeigerFelder++;
    }
    return (returnString);
  }

//################################################################################################
//Methoden zur Darstellung des Formulares
//################################################################################################

  public void anzeigen()
  {
    this.setLayout(null);

    //Button Treffer Kalkulieren
    this.buttonTreffer = new Button(this.BUTTON_TREFFER_KALKULIEREN);
    this.buttonTreffer.addActionListener(this);
    this.buttonTreffer.setBounds(600,154,110,20);
    this.add(this.buttonTreffer);

    //Button Mech Speichern
    this.buttonSpeicher = new Button(this.BUTTON_MECH_SPEICHERN);
    this.buttonSpeicher.addActionListener(this);
    this.buttonSpeicher.setBounds(714,154,80,20);
    this.add(this.buttonSpeicher);

    //Button zum Einfplegen der kritischen Treffer
    this.buttonEinpflegen = new Button(this.BUTTON_EINPFLEGEN);
    this.buttonEinpflegen.addActionListener(this);
    this.buttonEinpflegen.setBounds(320,300,40,40);
    this.add(this.buttonEinpflegen);

    //Textfield
    this.textTreffer = new TextArea();
    this.textTreffer.setBounds(600,44,160,100);
    this.textTreffer.setText(this.inhaltTextAreaTreffer);
    this.add(this.textTreffer);

    //Label fr Systemmeldungen
    this.meldungenSystem = new Label();
    this.meldungenSystem.setFont(new Font("Arial",Font.BOLD,12));
    this.meldungenSystem.setBounds(600,390,210,22);
    this.meldungenSystem.setBackground(Color.yellow);
    this.meldungenSystem.setText("Systemmeldungen");
    this.add(this.meldungenSystem);

    //Label fr Kritische
    this.meldungenKritische = new Label();
    this.meldungenKritische.setFont(new Font("Arial",Font.BOLD,12));
    this.meldungenKritische.setBounds(600,415,210,22);
    this.meldungenKritische.setBackground(Color.yellow);
    this.meldungenKritische.setText("keine Kritischen");
    this.add(this.meldungenKritische);

    //Label fr Zustand des Mechs
    this.meldungenZustand = new Label();
    this.meldungenZustand.setFont(new Font("Arial",Font.BOLD,12));
    this.meldungenZustand.setBounds(600,440,210,22);
    this.meldungenZustand.setBackground(Color.yellow);
    this.meldungenZustand.setText(this.beschreibungMechStatus[Integer.parseInt(this.parameterValues[6])]);
    this.add(this.meldungenZustand);

    //Checkboxes ber den Zustand
    for(int i=0; i<6; i++)
    {
      this.hitsPilotCB[i].setBounds(260+15*i,345,12,12);
      this.add(this.hitsPilotCB[i]);
      if(i<3)
      {
        this.reaktorCB[i].setBounds(260+15*i,300,12,12);
        this.add(this.reaktorCB[i]);
      }
      if(i<2)
      {
        this.gyroCB[i].setBounds(260+15*i,315,12,12);
        this.add(this.gyroCB[i]);

        this.lifeSupportCB[i].setBounds(260+15*i,330,12,12);
        this.add(this.lifeSupportCB[i]);
      }
    }

    //Checkboxes fr Location noch dran
    //Interne 0=RArm, 1=RBein, 2=RTorso, 3=TM, 4=LTorso, 5=LBein, 6=LArm, 7=Kopf
    this.locationIstDran[0].setBounds(100,198,15,15);
    this.locationIstDran[7].setBounds(250,198,15,15);
    this.locationIstDran[6].setBounds(480,198,15,15);
    this.add(this.locationIstDran[0]);
    this.add(this.locationIstDran[7]);
    this.add(this.locationIstDran[6]);
    this.locationIstDran[2].setBounds(100,378,15,15);
    this.locationIstDran[3].setBounds(290,378,15,15);
    this.locationIstDran[4].setBounds(480,378,15,15);
    this.add(this.locationIstDran[2]);
    this.add(this.locationIstDran[3]);
    this.add(this.locationIstDran[4]);
    this.locationIstDran[1].setBounds(180,558,15,15);
    this.locationIstDran[5].setBounds(400,558,15,15);
    this.add(this.locationIstDran[1]);
    this.add(this.locationIstDran[5]);

    //Checkboxes der internen
    for(int i=0; i<12; i++)
    {
      this.rArmCB[i].setBounds(8, 218+12*i, 10, 10);
      this.add(this.rArmCB[i]);
      this.lArmCB[i].setBounds(388, 218+12*i, 10, 10);
      this.add(this.lArmCB[i]);
      this.rTorsoCB[i].setBounds(8, 400+12*i, 10, 10);
      this.add(this.rTorsoCB[i]);
      this.mTorsoCB[i].setBounds(198, 400+12*i, 10, 10);
      this.add(this.mTorsoCB[i]);
      this.lTorsoCB[i].setBounds(388, 400+12*i, 10, 10);
      this.add(this.lTorsoCB[i]);
      if(i<6)
      {
        this.KopfCB[i].setBounds(198, 218+12*i, 10, 10);
        this.add(this.KopfCB[i]);
        this.rBeinCB[i].setBounds(88, 580+12*i, 10, 10);
        this.add(this.rBeinCB[i]);
        this.lBeinCB[i].setBounds(308, 580+12*i, 10, 10);
        this.add(this.lBeinCB[i]);
      }
    }

    //Textfield fr Hitze
    this.istHeatTF = new TextField(""+this.istHeat);
    this.istHeatTF.setBounds(690, 475, 24, 20);
    this.add(this.istHeatTF);

    //Textfields fr kritische
    for(int i=0; i<8; i++)
    {
      this.istKritischTF[i] = new TextField(""+this.istKritische[i]);
      this.istKritischTF[i].setFont(new Font("Arial",Font.PLAIN,10));
      this.istKritischTF[i].setBounds(170+40*i,728,20,16);
      this.add(this.istKritischTF[i]);
    }

    //Titel und Figur
    this.setTitle(this.parameterValues[0] + " / " + this.parameterValues[2]);

    //Alles anzeigen, damit automatisches aufrufen der Methode paint
    this.setVisible(true);
  }

  /**
   * Diese Methode wird jedesmal automatisch aufgerufen, wenn das Frame dargestellt wird.
   * Entsprechend sind hier alle Schritte zur Darstellung vereint.
   */
  public void paint(Graphics g)
  {
    //neue Titel, da sich die Figur gendert haben mag.
    this.setTitle(this.parameterValues[0] + " / " + this.parameterValues[2]);

    int basishoehe; //fr Restpanzerung und Interne
    Font font; //Schriftart
    int positionY;

    //Wrfelziele fr die Interne Darstellung
    int wuerfelY=1;
    String wuerfelX="1-3";

    //Darstellen der Basisinformationen:
    font = new Font("Arial",Font.BOLD,12);
    g.setFont(font);
    positionY=0;
    g.drawString("Name:",400,40+16*positionY++);
    g.drawString("Farbe/Figur:",400,40+16*positionY++);
    g.drawString("Gewicht/RT:",400,40+16*positionY++);
    g.drawString("Status:",400,40+16*positionY++);
    g.drawString("GS:",400,40+16*positionY++);
    g.drawString("WT/Hitze:",400,40+16*positionY++);
    g.drawString("Pilot:",400,40+16*positionY++);
    g.drawString("Hits:",400,40+16*positionY++);
    g.drawString("Hits R/G/LS:",400,40+16*positionY++);

    font = new Font("Arial",Font.PLAIN,12);
    g.setFont(font);
    positionY=0;
    g.drawString(this.parameterValues[0],480,40+16*positionY++); //Name
    g.drawString(this.parameterValues[1] + " / " + this.parameterValues[2],480,40+16*positionY++); //Farbe
    g.drawString(this.parameterValues[3] + " / " + this.translateReaktorType(this.parameterValues[4]),480,40+16*positionY++); //Gewicht + Reaktortyp
    g.drawString(this.translateMechStatus(this.parameterValues[6],1),480,40+16*positionY++); //MechStatus
    g.drawString(this.calcMechGeh(this.parameterValues[8]) + " / " + this.calcMechLauf(this.parameterValues[9]) + " / " + this.calcMechJump(this.parameterValues[10]),480,40+16*positionY++);
    g.drawString((this.istWT - this.istHitsReaktor * 5) + " (" + this.parameterValues[11] + ") / " + this.istHeat,480,40+16*positionY++);
    g.drawString(this.calcMechPilot(this.parameterValues[14]) + " / " + this.calcMechGunnery(this.parameterValues[15]) + " / " + this.parameterValues[16],480,40+16*positionY++);
    g.drawString("" + this.istHitsPilot,480,40+16*positionY++);
    g.drawString(this.istHitsReaktor + " / " + this.istHitsGyro + " / " + this.istHitsLifeSupport,480,40+16*positionY++);

    //Current Heat
    g.drawString("current Heat", 720, 490); //(690, 475, 24, 20);

    //Darstellen der kritischen Abfrage
    font = new Font("Arial",Font.BOLD,12);
    g.setFont(font);
    g.drawString("Aufgetretene kritische Treffer",40,680);
    g.drawString("Soll kritische Treffer:",20,720);
    g.drawString("Ist kritische Treffer:",20,740);
    font = new Font("Arial",Font.PLAIN,10);
    g.setFont(font);
    positionY=0;
    g.drawString("RArm", 170+40*positionY++, 700);
    g.drawString("RBein", 170+40*positionY++, 700);
    g.drawString("RTorso", 170+40*positionY++, 700);
    g.drawString("TM", 170+40*positionY++, 700);
    g.drawString("LTorso", 170+40*positionY++, 700);
    g.drawString("LBein", 170+40*positionY++, 700);
    g.drawString("LArm", 170+40*positionY++, 700);
    g.drawString("Kopf", 170+40*positionY++, 700);
    for(int i=0; i<8; i++)
    {
      g.drawString(""+this.sollKritische[i],170+40*i,720);
    }

    //berschrift ber das Textfenster
    font = new Font("Arial",Font.BOLD,12);
    g.setFont(font);
    g.drawString("Treffer z.B. f 10 5:",600,40);

    //Darstellen des Equipments:
    /**@todo: Paint: das Equpiment mu noch  besser dargestellt werden*/
    font = new Font("Arial",Font.BOLD,12);
    g.setFont(font);
    g.drawString("Equipment",600,210);
    font = new Font("Arial",Font.PLAIN,10);
    g.setFont(font);
    for(int i=0; i<this.equipment.size(); i++)
    {
      g.drawString((String) this.equipment.elementAt(i),600,226+16*i);
    }

    //Darstellung der Reaktor / Gyro / LifeSupport / MechPilot
    font = new Font("Arial",Font.BOLD,10);
    g.setFont(font);
    g.drawString("Reaktor:",200,310);
    g.drawString("Gyro:",200,325);
    g.drawString("LSupport:",200,340);
    g.drawString("MechPilot:",200,355);

    //Darstellen der Hitzeskala
    font = new Font("Arial",Font.BOLD,12);
    g.setFont(font);
    g.drawString("Hitzeskala",600,490);
    font = new Font("Arial",Font.PLAIN,12);
    positionY=0;
    g.setFont(font);
    g.drawString("30: Shutdown",600, 510+14*positionY++);
    g.drawString("28: Ammo Explosion 8+",600, 510+14*positionY++);
    g.drawString("26: Shutdown 10+",600, 510+14*positionY++);
    g.drawString("25: Movement Points -5",600, 510+14*positionY++);
    g.drawString("24: Gunnery +4",600, 510+14*positionY++);
    g.drawString("23: Ammo Explosion 6+",600, 510+14*positionY++);
    g.drawString("22: Shutdown 8+",600, 510+14*positionY++);
    g.drawString("20: Movement Points -4",600, 510+14*positionY++);
    g.drawString("19: Ammo Explosion 4+",600, 510+14*positionY++);
    g.drawString("18: Shutdown 6+",600, 510+14*positionY++);
    g.drawString("17: Gunnery +3",600, 510+14*positionY++);
    g.drawString("15: Movement Points -3",600, 510+14*positionY++);
    g.drawString("14: Shutdown 4+",600, 510+14*positionY++);
    g.drawString("13: Gunnery +2",600, 510+14*positionY++);
    g.drawString("10: Movement Points -2",600, 510+14*positionY++);
    g.drawString(" 8: Gunnery +1",600, 510+14*positionY++);
    g.drawString(" 5: Movement Points -1",600, 510+14*positionY++);

    //Darstellen der Internen Belegung
    font = new Font("Arial",Font.BOLD,12);
    g.setFont(font);

    g.drawString("Rechter Arm",10,210);
    g.drawString("Kopf",200,210);
    g.drawString("Linker Arm",390,210);

    g.drawString("Rechter Torso",10,390);
    g.drawString("Torso Mitte",200,390);
    g.drawString("Linker Torso",390,390);

    g.drawString("Rechtes Bein",90,570);
    g.drawString("Linkes Bein",310,570);

    font = new Font("Arial",Font.PLAIN,10);
    g.setFont(font);

    for(int i=0; i<12; i++)
    {
      if(wuerfelY>6){wuerfelY=1; wuerfelX="4-6";}
      g.drawString(wuerfelX + ", "+wuerfelY+":  "+(String) this.rArm[i],24,226+12*i);
      if(i<6){g.drawString(wuerfelY+": "+(String) this.Kopf[i],214,226+12*i);}
      g.drawString(wuerfelX + ", "+wuerfelY+": "+(String) this.lArm[i],404,226+12*i);

      g.drawString(wuerfelX + ", "+wuerfelY+": "+(String) this.rTorso[i],24,406+12*i);
      g.drawString(wuerfelX + ", "+wuerfelY+": "+(String) this.mTorso[i],214,406+12*i);
      g.drawString(wuerfelX + ", "+wuerfelY+": "+(String) this.lTorso[i],404,406+12*i);

      if(i<6){g.drawString(wuerfelY+": "+(String) this.rBein[i],104,586+12*i);}
      if(i<6){g.drawString(wuerfelY+": "+(String) this.lBein[i],324,586+12*i);}
      wuerfelY++;
    }

    //Darstellen des Schemas und konkrete Werte
    font = new Font("Arial",Font.PLAIN,10);
    g.setFont(font);
    //Syntax: (int x, int y, int width, int height)
    //rechter Arm
    g.drawRect(14, 78, 14, 60);
    g.drawString(""+this.istPanzerung[0],14,74);
    //rechtes Bein
    g.drawRect(40, 134, 24, 40);
    g.drawString(""+this.istPanzerung[1],44,186);
    //rechter Torso
    g.drawRect(32, 80, 18, 40);
    g.drawString(""+this.istPanzerung[2],34,76);
    //Toros Mitte
    g.drawRect(50, 70, 42, 60);
    g.drawString(""+this.istPanzerung[4],84,66);
    //Linker Torso
    g.drawRect(92, 80, 18, 40);
    g.drawString(""+this.istPanzerung[6],96,76);
    //linkes Bein
    g.drawRect(78, 134, 24, 40);
    g.drawString(""+this.istPanzerung[8],82,186);
    //Linker Arm
    g.drawRect(114, 78, 14, 60);
    g.drawString(""+this.istPanzerung[9],114,74);
    //Kopf
    g.drawRect(61, 56, 20, 10);
    g.drawString(""+this.istPanzerung[10],65,52);

    //TorsoRcken
    g.drawRect(144, 80, 12, 30);
    g.drawString(""+this.istPanzerung[3],146,76);
    g.drawRect(156, 75, 30, 40);
    g.drawString(""+this.istPanzerung[5],166,71);
    g.drawRect(186, 80, 12, 30);
    g.drawString(""+this.istPanzerung[7],188,76);


    //Auffllen entsprechend nach Restpanzerung
    //rechterArm
    g.fillRect(14, 78, 14, (int) 60 * this.istPanzerung[0] / this.sollPanzerung[0]);
    //rechtes Bein
    g.fillRect(40, 134, 24, (int) 40 * this.istPanzerung[1] / this.sollPanzerung[1]);
    //rechter Torso
    g.fillRect(32, 80, 18, (int) 40 * this.istPanzerung[2] / this.sollPanzerung[2]);
    //Toros Mitte
    g.fillRect(50, 70, 42, (int) 60 * this.istPanzerung[4] / this.sollPanzerung[4]);
    //Linker Torso
    g.fillRect(92, 80, 18, (int) 40 * this.istPanzerung[6] / this.sollPanzerung[6]);
    //linkes Bein
    g.fillRect(78, 134, 24, (int) 40 * this.istPanzerung[8] / this.sollPanzerung[8]);
    //Linker Arm
    g.fillRect(114, 78, 14, (int) 60 * this.istPanzerung[9] / this.sollPanzerung[9]);
    //Kopf
    g.fillRect(61, 56, 20, (int) 10 * this.istPanzerung[10] / this.sollPanzerung[10]);

    //TorsoRcken
    g.fillRect(144, 80, 12, (int) 30 * this.istPanzerung[3] / this.sollPanzerung[3]);
    g.fillRect(156, 75, 30, (int) 40 * this.istPanzerung[5] / this.sollPanzerung[5]);
    g.fillRect(186, 80, 12, (int) 30 * this.istPanzerung[7] / this.sollPanzerung[7]);

    //Syntax: (int x, int y, int width, int height)
    //rechter Arm
    g.drawRect(214, 78, 14, 60);
    g.drawString(""+this.istInterne[0],214,74);
    //rechtes Bein
    g.drawRect(240, 134, 24, 40);
    g.drawString(""+this.istInterne[1],244,186);
    //rechter Torso
    g.drawRect(232, 80, 18, 40);
    g.drawString(""+this.istInterne[2],234,76);
    //Toros Mitte
    g.drawRect(250, 70, 42, 60);
    g.drawString(""+this.istInterne[3],284,66);
    //Linker Torso
    g.drawRect(292, 80, 18, 40);
    g.drawString(""+this.istInterne[4],296,76);
    //linkes Bein
    g.drawRect(278, 134, 24, 40);
    g.drawString(""+this.istInterne[5],282,186);
    //Linker Arm
    g.drawRect(314, 78, 14, 60);
    g.drawString(""+this.istInterne[6],314,74);
    //Kopf
    g.drawRect(261, 56, 20, 10);
    g.drawString(""+this.istInterne[7],265,52);

    //Auffllen entsprechend nach RestInterne
    //rechterArm
    g.fillRect(214, 78, 14, (int) 60 * this.istInterne[0] / this.sollInterne[0]);
    //rechtes Bein
    g.fillRect(240, 134, 24, (int) 40 * this.istInterne[1] / this.sollInterne[1]);
    //rechter Torso
    g.fillRect(232, 80, 18, (int) 40 * this.istInterne[2] / this.sollInterne[2]);
    //Toros Mitte
    g.fillRect(250, 70, 42, (int) 60 * this.istInterne[3] / this.sollInterne[3]);
    //Linker Torso
    g.fillRect(292, 80, 18, (int) 40 * this.istInterne[4] / this.sollInterne[4]);
    //linkes Bein
    g.fillRect(278, 134, 24, (int) 40 * this.istInterne[5] / this.sollInterne[5]);
    //Linker Arm
    g.fillRect(314, 78, 14, (int) 60 * this.istInterne[6] / this.sollInterne[6]);
    //Kopf
    g.fillRect(261, 56, 20, (int) 10 * this.istInterne[7] / this.sollInterne[7]);
  }

//################################################################################################
//Sonstige
//################################################################################################


  /**
   * Diese Methode berprft, ob die Eingabe im Textfeld ok ist.
   */
  public boolean checkAndSplitTextValue()
  {
    boolean resultCheck = true;

    //Alle Eingabetrennzeichen auf , setzen insbesondere auch Returnzeichen,
    //damit nur noch ein langer String vorliegt
    this.inhaltTextAreaTreffer = this.inhaltTextAreaTreffer.replace(';',',');
    this.inhaltTextAreaTreffer = this.inhaltTextAreaTreffer.replace('.',',');
    this.inhaltTextAreaTreffer = this.inhaltTextAreaTreffer.replace('\r',',');
    this.inhaltTextAreaTreffer = this.inhaltTextAreaTreffer.replace('\n',' ');

    //Check MindestLnge
    if(this.inhaltTextAreaTreffer.length()<5){resultCheck = false;}
    else
    {

      //ein Trennzeichen am Ende entfernen
      if(this.inhaltTextAreaTreffer.charAt(this.inhaltTextAreaTreffer.length()-1) == ',')
      {
        this.inhaltTextAreaTreffer = this.inhaltTextAreaTreffer.substring(0,this.inhaltTextAreaTreffer.length()-1);
      }

      //Check Zone gegen {f, r, l, b}, 0<= TP <=20, Location = {2-12}
      //alle identifizierten einzeltreffer kommen standardisiert in den Vector
      //mit >Zone TP Location<
      this.einzelneTreffer = new Vector();

      int beginnIndex = 0;
      int endIndex = this.inhaltTextAreaTreffer.indexOf(",");
      String trefferTeilstring;
      boolean nichtLetztesElement = true;
      while(resultCheck && nichtLetztesElement)
      {
        if(endIndex<beginnIndex){nichtLetztesElement=false;endIndex = inhaltTextAreaTreffer.length();}

        trefferTeilstring = this.inhaltTextAreaTreffer.substring(beginnIndex, endIndex);

        //Leerzeichen am Anfang entfernen
        while(trefferTeilstring.charAt(0) == ' ')
        {
          trefferTeilstring = trefferTeilstring.substring(1,trefferTeilstring.length());
        }
        //Steht am Anfang kein {f, r, l, b} erfolgt abbruch
        if( trefferTeilstring.charAt(0) == 'f' ||
            trefferTeilstring.charAt(0) == 'r' ||
            trefferTeilstring.charAt(0) == 'l' ||
            trefferTeilstring.charAt(0) == 'b')
            {//alles ok
            }
            else
            {
              resultCheck = false;
              break;
            }
        //Leerzeichen am Ende entfernen
        while(trefferTeilstring.charAt(trefferTeilstring.length()-1) == ' ')
        {
          trefferTeilstring = trefferTeilstring.substring(0,trefferTeilstring.length()-1);
        }
        //jedes Leerzeichen an der dritten Position entfernen
        while(trefferTeilstring.charAt(2) == ' ')
        {
          trefferTeilstring = trefferTeilstring.charAt(0) +" "+trefferTeilstring.substring(3,trefferTeilstring.length());
        }
        //ist an der 4ten Position ein Leerzeichen, mu vor den Trefferpunkten eine 0
        if(trefferTeilstring.charAt(3) == ' ')
        {
          trefferTeilstring = trefferTeilstring.charAt(0) +" 0"+trefferTeilstring.substring(2,trefferTeilstring.length());
        }
        //jedes Leerzeichen an der sechsten Position entfernen
        while(trefferTeilstring.charAt(5) == ' ')
        {
          trefferTeilstring = trefferTeilstring.substring(0,4) +" "+trefferTeilstring.substring(6,trefferTeilstring.length());
        }
        //ist der String zu kurz, mu die Location um eine Null ergnzt werden
        if(trefferTeilstring.length()<7)
        {
          trefferTeilstring = trefferTeilstring.substring(0,5) +"0"+trefferTeilstring.substring(5,trefferTeilstring.length());
        }
        try
        {
          //Die Trefferpunkt mssen als Zahlen abbildbar sein
          Integer.parseInt(trefferTeilstring.substring(2,4));
          //Die Zone mu als Zahl abbildbar sein und zwischen 2 und 12 liegen
          if( Integer.parseInt(trefferTeilstring.substring(5,7))<2 ||
              Integer.parseInt(trefferTeilstring.substring(5,7))>12)
              {
                resultCheck = false;
                break;
              }
        }
        catch (NumberFormatException e)
        {
            resultCheck = false;
            break;
        }
        this.einzelneTreffer.add(trefferTeilstring);
        if(nichtLetztesElement){beginnIndex = endIndex+1;}
        if(nichtLetztesElement){endIndex = this.inhaltTextAreaTreffer.indexOf(",",beginnIndex);}
      }
      trefferTeilstring = this.inhaltTextAreaTreffer.substring(beginnIndex, this.inhaltTextAreaTreffer.length());
    }

    return resultCheck;
  }

//################################################################################################
//Methoden zur Event Behandlung
//################################################################################################

  /**
   * Diese Methode kalkuliert einen Treffer anhand konvertierter Angaben.
   * Sie ruft sich solange rekursiv selber auf, bis der Treffer aufgebraucht ist.
   * Als Eingabe wird erwartet, eine boolean (true = Treffer von Vorne, false =
   * Treffer von hinten), int (Trefferpunkte) und int (location nach eigener Tabelle)
   */
   public void doSingleTreffer(boolean TREFFER_VON_VORNE, int tp, int location)
   {
    int locIntern;
    int weitPanz;

    //Treffer reindrehen
    if(tp<=this.istPanzerung[location]){this.istPanzerung[location]-=tp;tp=0;}
    else
    {
      //Trefferpunkte sind grer als Restpanzer, d.h. Weiterleitung auf Interne

      //Abziehen Panzerung von TP
      tp-=this.istPanzerung[location];
      this.istPanzerung[location]=0;

      //Wenn die Interne bereits auf 0 ist, dann ist dies kein kritischer
      //sondern wird gleich weiter gereicht.

      //Welche Interne ist verantwortlich?
      locIntern = this.calc.locationTranslatePanzuInt(location);

      //Sollte die Interne durchschlagen werden, welche nchste Zone ist verantwortlich?
      weitPanz = this.calc.locationTransfer(locIntern, TREFFER_VON_VORNE);

      if(this.istInterne[locIntern]==0)
      {
        //gleich in die nchste Zone weiterleiten
        if(weitPanz<0){/*es gibt keinen nchste Zone*/ return;}
        {
          this.doSingleTreffer(TREFFER_VON_VORNE, tp, weitPanz);
        }
      }
      else
      {
        //es ist ein kritischer entstanden

        if(tp<=this.istInterne[locIntern])
          {
            this.istInterne[locIntern]-=tp;
            tp=0;
            this.sollKritische[locIntern]++;
          }
          else
          {
            //es mssen Treffer zur nchsten Zone weitergeleitet werden

            //Restinterne pltten, d.h. Interne ist ab.
            tp-=this.istInterne[locIntern];
            this.istInterne[locIntern]=0;
            this.sollKritische[locIntern]++;

            //Weiterleiten
            if(weitPanz<0){/*es gibt keinen nchste Zone*/ return;}
            {
              this.doSingleTreffer(TREFFER_VON_VORNE, tp, weitPanz);
            }
          }
      }
    }
   }

  /**
   * Diese Methode kalkuliert alle Treffer anhand des treffersVector, in dem
   * alle Treffer standardisiert eingetragen sind.
   */
   public void doAlleTreffer()
   {
    String zoneVonUser;
    String einzelnerTreffer;

    int tp;
    int locVonUser;
    int locVonProg;

    boolean TREFFER_VON_VORNE = true;

    //private Vector einzelneTreffer durchlaufen
    for(int i=0; i<this.einzelneTreffer.size(); i++)
    {
      einzelnerTreffer = (String) this.einzelneTreffer.get(i);

      //Variablen bersetzen
      zoneVonUser = einzelnerTreffer.substring(0,1);
      tp = Integer.parseInt(einzelnerTreffer.substring(2,4));
      locVonUser = Integer.parseInt(einzelnerTreffer.substring(5,7));
      locVonProg = this.calc.locationTranslate(zoneVonUser, locVonUser);

      //kritische Treffer direkt als kritische Eintragen
      //0=RArm, 1=RBein, 2=RTorso, 3=TM, 4=LTorso, 5=LBein, 6=LArm, 7=Kopf
      if(locVonUser == 2)
      {
        if(zoneVonUser.equals("f")){this.sollKritische[3]++;}
        if(zoneVonUser.equals("r")){this.sollKritische[2]++;}
        if(zoneVonUser.equals("l")){this.sollKritische[4]++;}
        if(zoneVonUser.equals("b")){this.sollKritische[3]++;}
      }

      if(zoneVonUser.equals("b")){TREFFER_VON_VORNE = false;}
      else{TREFFER_VON_VORNE = true;}

      this.doSingleTreffer(TREFFER_VON_VORNE, tp, locVonProg);
    }
   }

  /**
   * Diese Methode fngt alle Events ab und behandelt diese.
   */
  public void actionPerformed(ActionEvent event)
  {
    String cmd = event.getActionCommand();
    String sEvent = event.getActionCommand();

    //Es sind Treffer eingegangen
    if(event.getActionCommand().equals(this.BUTTON_TREFFER_KALKULIEREN))
    {
      this.inhaltTextAreaTreffer = this.textTreffer.getText();

      //hier erfolgt keine Verarbeitung, sondern die Zerlegung in
      //einen Vector, bei dem jedes Element nach {Zone} {TP} {Location} aufgebaut ist
      boolean inhaltOK = this.checkAndSplitTextValue();

      if(inhaltOK)
      {
        /*Verarbeitung*/
        //alle Treffer verarbeiten
        this.doAlleTreffer();
        this.recalculateHits();
        //Bild neu Zeichnen
        this.setVisible(false);
        this.show();
        //Text setzen
        this.inhaltTextAreaTreffer = "";
        this.textTreffer.setText(this.inhaltTextAreaTreffer);
        this.meldungenSystem.setText("Treffer sind bearbeitet");
      }
      else
      {
        /*keine Verarbeitung*/
        this.meldungenSystem.setText("Fehler => keine Bearbeitung");
        this.textTreffer.setText(this.inhaltTextAreaTreffer);
      }
    }

    //Es sind Treffer eingegangen
    if(event.getActionCommand().equals(this.BUTTON_MECH_SPEICHERN))
    {
      this.speichern();
      this.meldungenSystem.setText("erfolgreich gespeichert");
    }

    //nderungen bei Treffern mssen eingepflegt werden
    if(event.getActionCommand().equals(this.BUTTON_EINPFLEGEN))
    {
      this.recalculateHits();

      //Bild neu Zeichnen
      this.setVisible(false);
      this.show();
      this.meldungenSystem.setText("Daten wurden bernommen");
    }

  }

  /**
   * Diese Methode berechnet alle aktuellen Ist Werte, wie Pilotenhits,
   * Reaktortreffer, etc noch einmal neu, auf Basis der angekreuzten
   * Elemente. Darberhinaus wird auch der Status des Mechs neu gesetzt.
   */
  public void recalculateHits()
  {
      System.out.println("Mech.recalculateHits Anfang");
      this.istHitsPilot=0;
      this.istHitsReaktor=0;
      this.istHitsGyro=0;
      this.istHitsLifeSupport=0;

      //Durchlauf der Hits
      for(int i=0; i<6; i++)
      {
        if(!this.hitsPilotCB[i].getState()){this.istHitsPilot++;}
        if(i<3){if(!this.reaktorCB[i].getState()){this.istHitsReaktor++;}}
        if(i<2){if(!this.gyroCB[i].getState()){this.istHitsGyro++;}}
        if(i<2){if(!this.lifeSupportCB[i].getState()){this.istHitsLifeSupport++;}}
      }

      //Neue Hitze bernehmen
      this.istHeat = Integer.parseInt(this.istHeatTF.getText());

    /**
     * ob eine Zone weg ist, in so
     * einem Fall mssen dann alle Interne dieser Zone weggestrichen werden
     */
     for(int i=0; i<8; i++)
     {
      if(this.istInterne[i]==0){this.locationIstDran[i].setState(false);}
     }

     //Ist eine LocationIstDran auf false, mssen alle assoziierten Internen
     //auch auf False. Der Umkehrschlu ist nicht mglich, da einzelne Location
     //durchaus ausfallen knnen.
    if(!this.locationIstDran[0].getState()){/*RArm*/for(int i=0; i<12; i++){this.rArmCB[i].setState(false);}}
    if(!this.locationIstDran[1].getState()){/*RBein*/for(int i=0; i<6; i++){this.rBeinCB[i].setState(false);}}
    if(!this.locationIstDran[2].getState()){/*RTorso*/for(int i=0; i<12; i++){this.rTorsoCB[i].setState(false);}}
    if(!this.locationIstDran[3].getState()){/*MTorso*/for(int i=0; i<12; i++){this.mTorsoCB[i].setState(false);}}
    if(!this.locationIstDran[4].getState()){/*LTorso*/for(int i=0; i<12; i++){this.lTorsoCB[i].setState(false);}}
    if(!this.locationIstDran[5].getState()){/*LBein*/for(int i=0; i<6; i++){this.lBeinCB[i].setState(false);}}
    if(!this.locationIstDran[6].getState()){/*LArm*/for(int i=0; i<12; i++){this.lArmCB[i].setState(false);}}
    if(!this.locationIstDran[7].getState()){/*Kopf*/for(int i=0; i<6; i++){this.KopfCB[i].setState(false);}}

     //Kritische ist / soll abgleichen
     this.meldungenKritische.setText("keine Kritischen");
     for(int i=0; i<8; i++)
     {
      if(this.sollKritische[i] > Integer.parseInt(this.istKritischTF[i].getText()))
      {
        this.meldungenKritische.setText("es sind Kritische aufgetreten");
      }
      else
      {
        this.istKritische[i]=0;
        this.sollKritische[i]=0;
        this.istKritischTF[i].setText("0");
      }
     }

     //HITS durchrechnen, d.h. MechPilot, Gyro, Reaktor, LifeSupport
      this.parameterValues[6]="0";
      this.meldungenZustand.setText(this.beschreibungMechStatus[Integer.parseInt(this.parameterValues[6])]);

      if(this.istHitsGyro == 2)
      {
        this.parameterValues[6]="3";
        this.meldungenZustand.setText(this.beschreibungMechStatus[Integer.parseInt(this.parameterValues[6])]);
      }
      if(this.istHitsReaktor == 3)
      {
        this.parameterValues[6]="1";
        this.meldungenZustand.setText(this.beschreibungMechStatus[Integer.parseInt(this.parameterValues[6])]);
      }
      if(this.istHitsPilot == 6)
      {
        this.parameterValues[6]="2";
        this.meldungenZustand.setText(this.beschreibungMechStatus[Integer.parseInt(this.parameterValues[6])]);
      }
      if(this.istInterne[7] == 0) //Kopf
      {
        this.parameterValues[6]="2";
        this.meldungenZustand.setText(this.beschreibungMechStatus[Integer.parseInt(this.parameterValues[6])]);
      }
      if(this.istInterne[3] == 0) //TorsoMitte Intern
      {
        this.parameterValues[6]="1";
        this.meldungenZustand.setText(this.beschreibungMechStatus[Integer.parseInt(this.parameterValues[6])]);
      }
      if((this.istInterne[2] == 0 || this.istInterne[4] == 0) && Integer.parseInt(this.parameterValues[4]) == 1)
      { //Rechter oder Linker Torso sind weg, und der Mech hat XL
        this.parameterValues[6]="1";
        this.meldungenZustand.setText(this.beschreibungMechStatus[Integer.parseInt(this.parameterValues[6])]);
      }
  }

//################################################################################################
//Methoden zur Darstellung von Informationen, String Change
//################################################################################################

  /**
   * Diese Methode liefert den Status dieses Mechs als String.
   */
  public String lieferMechStatus()
  {
    return (this.beschreibungMechStatus[Integer.parseInt("0")]);
  }

  /**
   * Diese Methode bersetzt fr die Darstellung den Mechstatus von
   * einer Zahl in einen String oder anders herum.
   */
  public String translateMechStatus(String status, int command)
  {
    //Wenn command = 1 : bersetzen von Zahl zu String
    //Wenn command = 2 : bersetzen von String zu Zahl
    //von String zu Zahl.
    String neuerStatus = status;

    if(command==1 && status.length()<2)
    {
      //Status ist eine Ziffer und wird in eine Beschreibung gemapped
      neuerStatus = this.beschreibungMechStatus[Integer.parseInt(status)];
    }

    if(command==2 && status.length()>1)
    {
      //Status ist eine Beschreibung und wird in eine Ziffer gemapped
      for(int i=0; i<this.beschreibungMechStatus.length; i++)
      {
        if(this.beschreibungMechStatus[i].equals(status))
        {
          neuerStatus = ""+i;
        }
      }
    }
    return neuerStatus;
  }

  /**
   * Diese Methode kalkuliert den gltigen Mechpilotenwerte.
   * @todo: calcMechPilot: mu noch implementiert werden, Activatoren und Hitze.
   */
  public String calcMechPilot(String sollPilot)
  {
    //Bercksichtigung von Gyro
    int mali = this.istHitsGyro*3 + Integer.parseInt(sollPilot);

    return (""+mali);
  }

  /**
   * Diese Methode kalkuliert den gltigen MechGunnerywerte.
   */
  public String calcMechGunnery(String sollGunnery)
  {
    int iSollGun = Integer.parseInt(sollGunnery);
    iSollGun += this.calcHeat(2);
    return (""+iSollGun);
  }

  /**
   * Diese Methode kalkuliert die gltige Gehgeschwindigkeit.
   * @todo: calcMechGeh: mu noch implementiert werden, Activatoren, Hip.
   */
  public String calcMechGeh(String sollGeh)
  {
    int iSollGeh = Integer.parseInt(sollGeh);
    iSollGeh -= this.calcHeat(1);
    if(iSollGeh<1){iSollGeh=1;}
    return (""+iSollGeh);
  }

  /**
   * Diese Methode kalkuliert die gltige Laufgeschwindigkeit.
   */
  public String calcMechLauf(String sollGeh)
  {
    String istGeh = this.calcMechGeh(sollGeh);
    String sollLauf = ""+ ((int) (Integer.parseInt(istGeh)+0.5 ) * 1.5);
    return (istGeh);
  }

  /**
   * Diese Methode kalkuliert die gltige Jumpgeschwindigkeit.
   */
  public String calcMechJump(String sollJump)
  {
    return (sollJump);
  }

  /**
   * Diese Methode gibt Mali aufgrund von Hitze zurck, bezglich
   * int art = 1: Bewegung, art = 2: Gunnery
   */
   public int calcHeat(int art)
   {
    int returnMali=0;
    if(art==1)
    {
      //Bewegung
      returnMali=5;
      if(this.istHeat<=24){returnMali=4;}
      if(this.istHeat<=19){returnMali=3;}
      if(this.istHeat<=14){returnMali=2;}
      if(this.istHeat<=9){returnMali=1;}
      if(this.istHeat<=4){returnMali=0;}
    }
    if(art==2)
    {
      //Gunnery
      returnMali=4;
      if(this.istHeat<=23){returnMali=3;}
      if(this.istHeat<=16){returnMali=2;}
      if(this.istHeat<=12){returnMali=1;}
      if(this.istHeat<=7){returnMali=0;}
    }
    return returnMali;
   }

  /**
   * Diese Methode gibt einfach nur die richtige Bezeichnung
   * des Reaktortypes aus.
   */
  public String translateReaktorType(String sollType)
  {
    String beschreibung = sollType;
    if(sollType.equals("1"))
    {
      beschreibung="fusion";
    }
    if(sollType.equals("1"))
    {
      beschreibung="fusion XL";
    }
    return (beschreibung);
  }
}