package bttool;

/**
 * Diese Klasse dient ausschlielich dazu, um eingegebene Trefferzonen
 * auf interne Trefferzonen umzurechnen.
 */

public class calcLocation
{

  private int [] locFront = {4,4,4,0,0,1,2,4,6,8,9,9,10};
  private int [] locBack = {4,4,5,0,0,1,3,5,7,8,9,9,10};
  private int [] locRight = {4,4,4,0,0,1,2,4,6,8,9,9,10};
  private int [] locLeft = {4,4,4,0,0,1,2,4,6,8,9,9,10};

  private int [] locIntern = {0,1,2,2,3,3,4,4,5,6,7};

  private int [] locTransferFront = {2,2,4,-1,4,6,6,-1};
  private int [] locTransferBack = {3,3,5,-1,5,7,7,-1};

  //private location
  public calcLocation()
  {
  }

  /**
   * Diese Methode gibt einfach die Nummer der Zone zurck:
   * front = 1, rechts = 2, links = 3, rcken = 4
   */
  private int zoneTranslate(String zone)
  {
    int resultZone=1;
    if(zone.equals("f")){resultZone=1;}
    if(zone.equals("r")){resultZone=2;}
    if(zone.equals("l")){resultZone=3;}
    if(zone.equals("b")){resultZone=4;}
    return (resultZone);
  }

  /**
   * Diese Methode berechnet die richtige Location aufgrund der
   * Trefferzone. Dabei gelten folgende Annahmen:
   * 0=RArm, 1=RBein, 2=RTorsoFront, 3=RTorsoBack, 4=TMitteFront, 5=TMitteBack,
   * 6=LTorsoFront, 7=LTorsoBack, 8=LBein, 9=LArm, 10=Kopf
   *
   * Zone: 1=front, 2=rechts, 3=links, 4=rcken
   */
  public int locationTranslate(String sZone, int location)
  {
    int position=4;

    int iZone = this.zoneTranslate(sZone);

    //Front
    if(iZone == 1){position = this.locFront[location];}
    //rechts
    if(iZone == 4){position = this.locBack[location];}
    //links
    if(iZone == 3){position = this.locRight[location];}
    //rcken
    if(iZone == 2){position = this.locLeft[location];}

    return position;
  }

  /**
   * Diese Methode dient dazu, Panzerlocation auf Internelocation umzurechnen,
   * d.h. Eingabe ist die Nummer der Panzerlocation und Ausgabe ist die Nummer
   * der Internenlocation.
   *
   * Panzerung: 0=RArm, 1=RBein, 2=RTorsoFront, 3=RTorsoBack, 4=TMitteFront, 5=TMitteBack,
   * 6=LTorsoFront, 7=LTorsoBack, 8=LBein, 9=LArm, 10=Kopf
   *
   * Intern: 0=RArm, 1=RBein, 2=RTorso, 3=TM, 4=LTorso, 5=LBein, 6=LArm, 7=Kopf
   */
  public int locationTranslatePanzuInt(int locPan)
  {
    return this.locIntern[locPan];
  }

  /**
   * Diese Methode berechnet die nchste location, in die ein Treffer weitergeleitet
   * wird. Wird -1 zurckgeliefert, ist der Treffer nicht weiterleitbar, d.h. entweder
   * Kopf oder TorsoMitte durchschlagen. Es wird der Wert der Location, Intern
   * erwartet von der Weitergeleitet werden soll und ob es sich um einen Treffer von
   * Vorne oder von Hinten handelt.
   *
   * Intern: 0=RArm, 1=RBein, 2=RTorso, 3=TM, 4=LTorso, 5=LBein, 6=LArm, 7=Kopf
   */
   public int locationTransfer(int sourceLocInt, boolean TREFFER_VON_VORNE)
   {

    int returnTargetLoc=-1;

    if(TREFFER_VON_VORNE){returnTargetLoc = this.locTransferFront[sourceLocInt];}
    else{returnTargetLoc = this.locTransferBack[sourceLocInt];}

    return returnTargetLoc;
   }
}